#!/usr/bin/env python
import branchpredictor
import math

# You might want to store the BHR size here to help figure out
# subsequent predictor parameters. (Optional!)
BHR_SIZE = None

# Constants that bound the parameter space.
MAX_BHR_SIZE = 12
MAX_SC_BITS = 4
MAX_PC_BITS = 10

def find_branch_history_register_size(bpred):
    global BHR_SIZE # (You need "global" in Python to be able to write to
                    # variables outside of function scope.)

    # TODO: your code here

    BHR_SIZE = None # (See above.)
    return None

def find_saturating_counter_bits(bpred):
    # TODO: your code here
    return None

def find_pc_bits_used(bpred):
    # TODO: your code here
    return None

def find_branch_history_table_entries(bpred):
    # TODO: your code here
    return None

def discover(bpred):
    # This function collects your results and returns them in a
    # dictionary. You can add/remove reset() calls or reorder the
    # calls to your functions if you wish, but please keep the
    # structure of the returned dictionary the same for our grading
    # scripts.
    results = {}
    bpred.reset()
    results['bhr size'] = find_branch_history_register_size(bpred)
    bpred.reset()
    results['saturating counter bits'] = find_saturating_counter_bits(bpred)
    bpred.reset()
    results['bht entries'] = find_branch_history_table_entries(bpred)
    return results

if __name__ == '__main__':
    # When run as a script, we'll analyze each of the provided branch
    # predictors.
    for name, bpred in branchpredictor.mystery_predictors:
        results = discover(bpred)
        print '%s:' % name
        for k, v in results.items():
            print '  %s: %s' % (k, v)
        print
